=== debian/changelog ===
vzlogger (0.8.6-2) unstable; urgency=medium

  * Added patch that removes an assert for a time duration (Closes: #1071728) 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Sat, 25 May 2024 07:41:06 +0200

vzlogger (0.8.6-1) unstable; urgency=medium

  * New upstream release (Closes: #1070430)
  * Fixed passing of hardening flags to cmake 
  * Bumped Standards-Version to 4.7.0
  * Fixed several Lintian info level issues
  * Moved configuration change from git to quilt patch 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Fri, 17 May 2024 06:32:32 +0200

vzlogger (0.8.3-1) unstable; urgency=medium

  * Initial upload (Closes: #864255) 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Mon, 04 Mar 2024 19:03:44 +0100
