=== debian/control ===
Source: vzlogger
Section: net
Priority: optional
Maintainer: Joachim Zobel <jz-2017@heute-morgen.de>
Build-Depends: debhelper-compat (= 13),
 pkgconf,
 libjson-c-dev,
 libcurl4-openssl-dev,
 libmicrohttpd-dev (>= 0.4.6),
 libsml-dev (>= 1.0),
 cmake,
 libsasl2-dev,
 libssl-dev (>= 3.0),
 libgcrypt-dev,
 libgnutls28-dev,
 uuid-dev,
 libunistring-dev,
 libgmock-dev,
 libgtest-dev,
 pandoc,
 libmosquitto-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: http://wiki.volkszaehler.org/software/controller/vzlogger
Vcs-Git: https://github.com/volkszaehler/vzlogger.git -b debian
Vcs-Browser: https://github.com/volkszaehler/vzlogger/tree/debian

Package: vzlogger
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Pre-Depends: ${misc:Pre-Depends}
Description: program for logging measurements to a volkszaehler.org middleware
 vzlogger...
  * is a tool to read and log measurements of a wide variety of smartmeters and
    sensors to the volkszaehler.org middleware.
  * can run as a daemon or via Cron.
  * includes a tiny onboard httpd to serve
    realtime readings to the AJAX web frontend.
  * is written in C++.
