=== debian/watch ===
version=4
https://github.com/volkszaehler/vzlogger/tags .*/v?(\d.*)@ARCHIVE_EXT@
