## vzlogger 0.8.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 # -*- mode: cmake; -*-
+# CMake 4 won't build without
+cmake_minimum_required(VERSION 3.5)
 project(vzlogger)
-cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)
 if(POLICY CMP0011)
   cmake_policy(SET CMP0011 NEW)
 endif(POLICY CMP0011)
@@ -11,7 +12,7 @@
 
 set(VZLOGGER_MAJOR_VERSION 0)
 set(VZLOGGER_MINOR_VERSION 8)
-set(VZLOGGER_SUB_VERSION 6)
+set(VZLOGGER_SUB_VERSION 9)
 set(VERSION_SEP "-")
 set(VZLOGGER_SHORT_VERSION "${VZLOGGER_MAJOR_VERSION}${VERSION_SEP}${VZLOGGER_MINOR_VERSION}")
 set(VZLOGGER_VERSION "${VZLOGGER_SHORT_VERSION}${VERSION_SEP}${VZLOGGER_SUB_VERSION}")
