=== debian/changelog ===
vzlogger (0.8.9-1) unstable; urgency=medium

  * New upstream release (Closes: #1113626, #1114439)
  * Migrated watch file to version 5
  * d/vzlogger.postinst: Compatibility fix to have bullseye accept usernames 
    with underscore

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Thu, 02 Oct 2025 05:48:53 +0200
