=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libgtest-dev,
  pandoc,
  libmosquitto-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: http://wiki.volkszaehler.org/software/controller/vzlogger
 Vcs-Git: https://github.com/volkszaehler/vzlogger.git -b debian
