=== debian/watch ===
Version: 5

Source: https://github.com/volkszaehler/vzlogger/tags
Matching-Pattern: .*/v?(\d.*)@ARCHIVE_EXT@
